;ein simples Demo-Beispiel frs Stringgadget-Interface mit Eingabefenster

XIncludeFile "\Bremer\BeispieleXX\Interface\Interface_Strg04.pbi"

Enumeration
 #main_window
 #sub_window
 #but_subsave
 #but_subende
 #but1 
 #but2
 #but9
EndEnumeration

Global Dim ic.IcStringGadget(0)

Procedure SubWindowOpen(titel$,br=0,hh=0)
  DisableWindow(#main_window,1)
  x = 50 + WindowX(#main_window) 
  y = 30 + WindowY(#main_window) 
  z = 450
  If br = 0: br = z: EndIf
  If hh = 0: hh = z: EndIf
  buttonbr = 95: buttonhh = 22
  OpenWindow(#sub_window, x, y, br, hh, titel$, 0, WindowID(#main_window)) 
  AddKeyboardShortcut(#sub_window, #PB_Shortcut_Escape, #but_subende)
  x1 = 11 :x2 = br - buttonbr - 11: y = hh - buttonhh - 11
  ButtonGadget(#but_subsave, x1, y, buttonbr, buttonhh, "Save")
  ButtonGadget(#but_subende, x2, y, buttonbr, buttonhh, "Close")
ProcedureReturn z  
EndProcedure

Procedure SubWindowClose()
  CloseWindow(#sub_window): DisableWindow(#main_window,0)
EndProcedure

Procedure InputWindow1()
Shared inputWindow 
  
  inputWindow = 1  
  SubWindowOpen("Test",600)
  
  ReDim ic.IcStringGadget(3)
  
  x = 20 : y = 40: br = 150: hh = 22: txtbr = 140
  ic(1) = IcStringGadget(#PB_Any,x,y,80,hh,"123456789")
  ic(1) \ MaxChar(9)
  ic(1) \ setFrontColor(#Red)
  ic(1) \ Helptext("max 9 Zeichen wird erwartet")
  ic(1) \ Textfeld("Geben sie 9 Zeichen ein",txtbr)
  ic(1) \ setFocus()
  ic(1) \ CursorPos(7)
  
  x = ic(1) \ Nextx() : y = ic(1) \ Y()
  ic(2) = IcStringGadget(#PB_Any,x,y,br,hh,"")
  ic(2) \ MaxChar(7)
  ic(2) \ setFrontColor(#Blue)
  ic(2) \ Helptext("max 7 Zeichen wird erwartet")
  ic(2) \ Textfeld("Geben sie 9 Zeichen ein",txtbr)
  
  x = ic(1) \ X() : y = ic(1) \ NextY()
  ic(3) = IcStringGadget(#PB_Any,x,y,br,hh,"")
  ic(3) \ MaxChar(7)
  ic(3) \ Dezimal(2)
  ic(3) \ setFrontColor(#Blue)
  ic(3) \ SelectAll()
  ic(3) \ Helptext("max 7 stellige Zahl wird erwartet, incl. 2 Dezimalstellen")
  ic(3) \ Textfeld("Geben sie was ein",txtbr)

EndProcedure

Procedure InputWindow2()
Shared inputWindow

  inputWindow = 2
  SubWindowOpen("Test 2")
  
  ReDim ic.IcStringGadget(4)
  
  x = 20 : y = 40: br = 150: hh = 22
  ic(1) = IcStringGadget(#PB_Any,x,y,br,hh,"Hallo")
  ic(1) \ MaxChar(5)
  ic(1) \ Helptext("nur 5 Zeichen Platz")
  ic(1) \ setFocus()
  
  y + hh + 10
  ic(2) = IcStringGadget(#PB_Any,x,y,br,hh,"irgendein Text",#PB_Text_Center)
  ic(2) \ setFrontColor(#Blue)
  ic(2) \ SelectAll()
  ic(2) \ Helptext("geben Sie ein was Sie wollen")
  
  y + hh + 10
  ic(3) = IcStringGadget(#PB_Any,x,y,br,hh,"",#PB_Text_Right)
  ic(3) \ MaxChar(12)
  ic(3) \ Dezimal(2)
  ic(3) \ TFormat()   ;Tausender Zeichen 
  ic(3) \ Helptext("max 12 stellige Zahl wird erwartet, incl. 2 Dezimalstellen")
  
  y + hh + 10
  ic(4) = IcStringGadget(#PB_Any,x,y,br,hh,"20.33")
  ic(4) \ MaxChar(6)
  ic(4) \ Dezimal(2)
  ic(4) \ SelectAll()
  ic(4) \ Helptext("max 6 stellige Zahl wird erwartet, incl. 2 Dezimalstellen")
  
  ic(4) \ IsLast(ic(4)\idnr())
  ic(4) \ IsFirst(ic(1)\idnr())
  
EndProcedure

Procedure InputWindowSave()
Shared inputWindow

  max = ArraySize(ic())
  Select inputWindow
    Case 1: dat$ = "Fenster1.dat"
            For j = 1 To max: Debug ic(j)\getText(): Next
                
    Case 2: dat$ = "Fenster2.dat"
            For j = 1 To max: Debug ic(j)\getText(): Next    
    ;usw
  EndSelect  
EndProcedure

Procedure.i InputWindow_Event(wb)
Shared inputWindow 
;nur ein Beispiel um auf Focus oder LostFocus 
;etc zustzlich zu reagieren 

max = ArraySize(ic())  

If inputWindow = 1
   For j = 1 To max
       If wb = ic(j)\pbnr()
          Debug j
       EndIf
   Next       
ElseIf inputWindow = 2
   For j = 1 To max
       If wb = ic(j)\pbnr()
          Debug j
       EndIf
   Next       
EndIf

ProcedureReturn wb  
EndProcedure
  
OpenWindow(#main_window,140,150,600,500,"Gadget",#PB_Window_SystemMenu);|1)
ButtonGadget(#but1,10,40,150,25,"Eingabemaske 1")
ButtonGadget(#but2,10,90,150,25,"Eingabemaske 2")

ButtonGadget(#but9,10,190,150,25,"?")
        
;=====================================================

Repeat
  event = WaitWindowEvent()   
        
  If Event = #PB_Event_Gadget Or Event = #PB_Event_Menu 
     wb = EventGadget()
     ;wb = InputWindow_Event(wb)  ;fr Sonstige Verarbeitung
     
     Select wb
        Case #but1: InputWindow1()
        Case #but2: InputWindow2()
        
        Case #but_subsave: InputWindowSave()
        Case #but_subende: SubWindowClose()
     EndSelect      
  EndIf

Until event = #PB_Event_CloseWindow 

End

; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 96
; FirstLine = 81
; Folding = 0-
; EnableXP
; EnableCompileCount = 11
; EnableBuildCount = 0
; EnableExeConstant